diff --git a/modules/pico_aodv.c b/modules/pico_aodv.c
index f60060fbc..b22dc77b2 100644
--- a/modules/pico_aodv.c
+++ b/modules/pico_aodv.c
@@ -86,11 +86,9 @@ static void aodv_elect_route(struct pico_aodv_node *node, union pico_address *gw
         pico_ipv4_route_del(node->dest.ip4, HOST_NETMASK, node->metric);
         if (!gw) {
             pico_ipv4_route_add(node->dest.ip4, HOST_NETMASK, ANY_HOST, 1, pico_ipv4_link_by_dev(dev));
-            printf("Added neighbor %08x\n", node->dest.ip4);
             node->metric = 1;
         } else {
             node->metric = metric;
-            printf("Added node %08x via %08x metric %d\n", node->dest.ip4, gw->ip4, metric);
             pico_ipv4_route_add(node->dest.ip4, HOST_NETMASK, gw->ip4, metric, NULL);
         }
     }
@@ -462,7 +460,7 @@ static void aodv_retrans_rreq(pico_time now, void *arg)
         node->rreq_retry = 0;
         node->ring_ttl = 0;
         pico_aodv_dbg("Node is unreachable.\n");
-        node->flags &= (~PICO_AODV_NODE_ROUTE_DOWN);
+        node->flags &= (uint16_t)(~PICO_AODV_NODE_ROUTE_DOWN);
         return;
     }
 
@@ -483,7 +481,7 @@ static void aodv_retrans_rreq(pico_time now, void *arg)
         }
     }
     if (node->ring_ttl < AODV_NET_DIAMETER)
-        node->ring_ttl += AODV_TTL_INCREMENT;
+        node->ring_ttl = (uint8_t)(node->ring_ttl + AODV_TTL_INCREMENT);
     pico_timer_add((pico_time)AODV_RING_TRAVERSAL_TIME(node->ring_ttl), aodv_retrans_rreq, node);
 }
 
@@ -534,8 +532,8 @@ static int aodv_send_req(struct pico_aodv_node *node)
 static void pico_aodv_expired(struct pico_aodv_node *node)
 {
     node->flags |= PICO_AODV_NODE_UNREACH;
-    node->flags &= (~PICO_AODV_NODE_ROUTE_UP);
-    node->flags &= (~PICO_AODV_NODE_ROUTE_DOWN);
+    node->flags &= (uint8_t)(~PICO_AODV_NODE_ROUTE_UP);
+    node->flags &= (uint8_t)(~PICO_AODV_NODE_ROUTE_DOWN);
     pico_ipv4_route_del(node->dest.ip4, HOST_NETMASK, node->metric);
     node->ring_ttl = 0;
     /* TODO: send err */
@@ -547,6 +545,7 @@ static void pico_aodv_collector(pico_time now, void *arg)
     struct pico_tree_node *index;
     struct pico_aodv_node *node;
     (void)arg;
+    (void)now;
     pico_tree_foreach(index, &aodv_nodes){
         node = index->keyValue;
         if (PICO_AODV_ACTIVE(node)) {
diff --git a/test/unit/modunit_pico_aodv.c b/test/unit/modunit_pico_aodv.c
index 5c3fe1085..49675e508 100644
--- a/test/unit/modunit_pico_aodv.c
+++ b/test/unit/modunit_pico_aodv.c
@@ -127,19 +127,62 @@ END_TEST
 
 START_TEST(tc_aodv_peer_new)
 {
-   /* TODO: test this: static struct pico_aodv_node *aodv_peer_new(const union pico_address *addr) */
+    union pico_address addr;
+    struct pico_aodv_node *new;
+    addr.ip4.addr = 0x44444444;
+    new = aodv_peer_new(&addr);
+    fail_if(!new);
+    fail_if(!get_node_by_addr(&addr));
+    pico_set_mm_failure(1);
+    new = aodv_peer_new(&addr);
+    fail_if(new);
 }
 END_TEST
 START_TEST(tc_aodv_peer_eval)
 {
-   /* TODO: test this: static struct pico_aodv_node *aodv_peer_eval(union pico_address *addr, uint32_t seq, int valid_seq) */
+    union pico_address addr;
+    struct pico_aodv_node *node = NULL;
+    /* Case 0: Creation */
+    addr.ip4.addr = 0x11224433;
+    node = aodv_peer_eval(&addr, 0, 0);
+    fail_if(!node);
+    fail_if((node->flags & PICO_AODV_NODE_SYNC) != 0); /* Not synced! */
+
+    /* Case 1: retrieve, unsynced */
+    node->metric = 42;
+    node = aodv_peer_eval(&addr, 0, 0); /* Should get existing node! */
+    fail_if(!node);
+    fail_if(node->metric != 42);
+    fail_if((node->flags & PICO_AODV_NODE_SYNC) != 0); /* Not synced! */
+
+
+    /* Case 2: new node, invalid allocation */
+    addr.ip4.addr = 0x11224455;
+    pico_set_mm_failure(1);
+    node = aodv_peer_eval(&addr, long_be(10), 1);
+    fail_if(node);
+
+    /* Case 3: existing node, setting the new sequence */
+    addr.ip4.addr = 0x11224433;
+    node = aodv_peer_eval(&addr, long_be(10), 1); /* Should get existing node! */
+    fail_if(node->metric != 42);
+    fail_if((node->flags & PICO_AODV_NODE_SYNC) == 0);
+    fail_if(node->dseq!= 10);
 }
 END_TEST
+
 START_TEST(tc_aodv_lifetime)
 {
-   /* TODO: test this: static uint32_t aodv_lifetime(struct pico_aodv_node *node) */
+    struct pico_aodv_node node;
+    pico_time now = PICO_TIME_MS();
+    memset(&node, 0, sizeof(node));
+    fail_if(aodv_lifetime(&node) == 0);
+    fail_if(node.last_seen < now);
+    node.last_seen = now - AODV_ACTIVE_ROUTE_TIMEOUT;
+    fail_if(aodv_lifetime(&node) != 0);
 }
 END_TEST
+
 START_TEST(tc_aodv_send_reply)
 {
    /* TODO: test this: static void aodv_send_reply(struct pico_aodv_node *node, struct pico_aodv_rreq *req, int node_is_local, struct pico_msginfo *info) */
